#include "Vram.h"
#include "Chars.h"
#include "Sprite.h"
#include "VVram.h"
#include "CopyMemory.h"
#include "Star.h"
#include"Fort.h"
#include "Barrier.h"

extern byte[] MonoPatternSource, ColorPatternSource, SpritePattern;
constexpr byte SourceCharSize = 8 * 3;

byte[48 * Char_End] CharPattern;

void InitVram()
{
    ClearScreen();
    MakePatternMono(Char_Ascii, MonoPatternSource + Char_Ascii * CharHeight, 64, 0x07);
    MakePatternMono(Char_Logo, MonoPatternSource + Char_Logo * CharHeight, 16, 0x05);
    MakePatternMono(Char_Barrier, MonoPatternSource + Char_Barrier * CharHeight, 2, 0x06);
    MakePatternMono(Char_Map, MonoPatternSource + Char_Map * CharHeight, 2, 0x15);
    MakePatternMono(Char_Star, MonoPatternSource + Char_Star * CharHeight, 1, 0x07);
    MakePatternColor(Char_BarrierHead, ColorPatternSource, Char_End - Char_BarrierHead);
}


void DrawAll()
{
    if (VVramChanged) {
        FillMemory(VVram, VVramWidth * VVramHeight, 0);
        DrawStars();
        DrawForts();
        DrawBarriers();
    }
    EraseSprites();
    VVramToVram();
    DrawSprites();
    SwapVram();
}


word PrintC(word vram, byte c)
{
    return Put(vram, c - ' ');
}


void Put2(word vram, byte c)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, c);
            ++c;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}

void Erase2(word vram)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, Char_Space);
        }
        vram += VramRowSize - 2 * VramStep;
    }
}

void Put4(word vram, ptr<byte> pBytes)
{
    repeat(4) {
        repeat(4) {
            Put(vram, *pBytes);
            ++pBytes;
            vram += VramStep;
        }
        vram += VramRowSize - 4 * VramStep;
    }
}