include "Vram.inc"
include "VVram.inc"
; include "Chars.inc"

ext CharPattern_, SpritePattern_
ext VVram_

VramTop equ Vram+4

zseg
charColor:
    defb 0
invertedByte:
    defb 0
; planeCount:
;     defb 0
yCount:
    defb 0
xCount:
    defb 0
dotCount:
    defb 0
pVram:
    defw 0
xSize:
    defb 0


dseg
Backup:
Backup0:
	defs VVramWidth*VVramHeight
Backup1:
	defs VVramWidth*VVramHeight
VramBank:
    defb 0
pBackup: public pBackup
	defw 0


; void MakePatternMono(byte c, ptr<byte> pSource, byte count, byte color);
dseg
MakePatternMono_@Param2: public MakePatternMono_@Param2
    defb 0
MakePatternMono_@Param3: public MakePatternMono_@Param3
    defb 0
cseg
MakePatternMono_: public MakePatternMono_
    pshs a,b,x,y
        ldb #PatternSize
        mul
        addd #CharPattern_
        tfr d,x
        do
            lda MakePatternMono_@Param3 ; color
            sta <charColor

            ldb #3
            do
                pshs b
                    lda #CharHeight | sta <yCount
                    do
                        clrb
                        lda <charColor
                        bita #$01
                        if ne
                            orb ,y
                        endif
                        bita #$10
                        if ne
                            lda ,y
                            coma
                            sta <invertedByte
                            orb <invertedByte
                        endif
                        stb ,x+
                        leay 1,y
                        dec <yCount
                    while ne | wend
                    leay -CharHeight,y
                    lsr <charColor
                puls b
                decb
            while ne | wend
            leay CharHeight,y
            dec MakePatternMono_@Param2
        while ne | wend
    puls a,b,x,y
rts


; void MakePatternColor(byte c, ptr<byte> pSource, byte count);
dseg
MakePatternColor_@Param2: public MakePatternColor_@Param2
    defb 0
cseg
MakePatternColor_: public MakePatternColor_
    pshs a,b,x,y
        ldb #PatternSize
        mul
        addd #CharPattern_
        tfr d,x
        do
            ldb #PatternSize
            do
                lda ,y+
                sta ,x+
                decb
            while ne | wend
            dec MakePatternColor_@Param2 ; count
        while ne | wend
    puls a,b,x,y
rts


; void ClearScreen();
cseg
ClearPage:
    ldx #0
    do
        clr ,x+
        cmpx #$1000
    while ne | wend
rts

ClearScreen_: public ClearScreen_
    pshs a,b,x,y
        lda #$07 | sta $fe21
        lda #$b0
        do
            sta $fe00
            bsr ClearPage
            inca
            cmpa #$b4
        while ne | wend
        lda #$bc | sta $fe00
        bsr ClearPage

        ldx #Backup
        ldy #VVramWidth*VVramHeight*2
        do
            clr ,x+
            leay -1,y
        while ne | wend

        lda #$e0 | sta $FE23
        lda #$b2 | sta VramBank
        ldx #Backup1 | stx pBackup
    puls a,b,x,y
rts


cseg
Put:
    lda $fe00 | inca | sta $fe01
    lda #1
    do
        pshs a
            sta $fe21
            ldb #CharHeight
            do
                lda ,y+
                sta ,x
                leax $400,x
                decb
            while ne | wend
            leax -$400*CharHeight,x
        puls a
        lsla
        cmpa #8
    while ne | wend
rts


; word Put(word vram, byte c);
cseg
Put_: public Put_
    pshs y
        lda #PatternSize
        mul
        addd #CharPattern_
        tfr d,y
        lda #$b0 | sta $fe00
        bsr Put
        leay -CharHeight*3,y
        lda #$b2 | sta $fe00
        bsr Put
    puls y
    tfr x,d
    addd #1
rts


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
    pshs a,b,x,y
        lda VramBank
        sta $fe00

        ldx #VramTop
        stx <pVram
        ldx #VVram_
        ldy pBackup
        lda #VVramHeight
        sta <yCount
        do
            lda #VVramWidth
            sta <xCount
            do 
                ldb ,x+
                cmpb ,y
                if ne
                    stb ,y
                    pshs x,y
                        lda #PatternSize
                        mul
                        addd #CharPattern_
                        tfr d,y
                        ldx <pVram
                        bsr Put
                    puls x,y
                endif
                leay 1,y
                pshs x
                    ldx <pVram
                    leax 1,x
                    stx <pVram
                puls x
                dec <xCount
            while ne | wend
            pshs x
                ldx <pVram
                leax VramWidth-VVramWidth,x
                stx <pVram
            puls x
            dec <yCount
        while ne | wend
    puls a,b,x,y
rts


; void SwapVram();
cseg
SwapVram_: public SwapVram_
    pshs a,x
        lda VramBank
        anda #$02
        if eq
            lda #$e0 | sta $FE23
            lda #$b2 | sta VramBank
            ldx #Backup1 | stx pBackup
        else
            lda #$e2 | sta $FE23
            lda #$b0 | sta VramBank
            ldx #Backup0 | stx pBackup
        endif
    puls a,x
rts


; void EraseBackup(byte x, byte y, byte size);
dseg
EraseBackup_@Param2: public EraseBackup_@Param2
    defb 0
cseg
EraseBackup_: public EraseBackup_
    pshs a,b,x
        pshs a
            lda #VVramWidth
            mul
            addd #Backup0
            tfr d,x
        puls a
        leax a,x

        cmpa #VVramWidth-1
        if cs
            ldb EraseBackup_@Param2
        else
            ldb #1
        endif
        stb <xSize

        lda #$ff
        ldb EraseBackup_@Param2
        do
            pshs b,x
                ldb <xSize
                do
                    sta Backup1-Backup0,x
                    sta ,x+
                    decb
                while ne | wend
            puls b,x
            leax VVramWidth,x
            decb
        while ne | wend
    puls a,b,x
rts


; void DrawSprite(byte x, byte y, byte pattern, byte size);
dseg
DrawSprite_@Param2: public DrawSprite_@Param2
    defb 0
DrawSprite_@Param3: public DrawSprite_@Param3
    defb 0
cseg
DrawSprite_: public DrawSprite_
    pshs a,b,x,y
        pshs a
            lda #VramRowSize
            mul
            addd #VramTop
            tfr d,y
        puls a
        leay a,y

        cmpa #VVramWidth-1
        if cs
            ldb DrawSprite_@Param3
        else
            ldb #1
        endif
        stb <xSize

        lda DrawSprite_@Param2
        ldb #CharHeight*4*4
        mul
        addd #SpritePattern_
        tfr d,x

        lda VramBank | sta $fe00
        inca | sta $fe01
        lda DrawSprite_@Param3 | sta <yCount
        do
            pshs x,y
                lda <xSize | sta <xCount
                do
                    lda #CharHeight | sta <dotCount
                    do
                        lda ,x+ | coma | sta <invertedByte
                        lda #1
                        do
                            pshs a
                                sta $fe21

                                lda ,y
                                anda <invertedByte
                                ora ,x+
                                sta ,y
                            puls a
                            lsla
                            cmpa #8
                        while ne | wend
                        leay $400,y
                        dec <dotCount
                    while ne | wend
                    leay -$400*CharHeight+1,y
                    dec <xCount
                while ne | wend
            puls x,y
            leay VramRowSize,y
            leax CharHeight*4*2,x
            dec <yCount
        while ne | wend
    puls a,b,x,y
rts
